/********************************************************************
		PopDATE - INITIALIZATION DATA
	   (c) Copyright 1992 by Omega Point, Inc.
		   Author: Ratko V. Tomic
*********************************************************************/

#include "cr.h"


int use_lim=1;	/* Set to 0 if no move_to_lim() with PDK-1 */
int quiet=0;	/* Set to NZ if no waiting for key on 1st screen */

/***********************************************************************
           SIGNON SCREEN & ERROR MESSAGES
*************************************************************************/

/* Video attributes for signon screen. */

char hello_atr[]={0x1b,0x1e,0x1f,0x1C,0x4e,0x19,7,0x17,0x1E,0x13,0x1F,0x1B};
char  mono_atr[]={0x70,0x70,0x70,0x70,0x0f,0x70,7,0x07,0x0F,0x07,0x07,0x07};

char first_msg[]="`c`2 `\xc3`]`6`[`@`m  `U`g`[`m`2\
`\xF PopDATE, Ver 1.26 - TSR Calendar `w\
`\xE Copyright (C) 1992 Omega Point, Inc. `w\
`5`w`0\
  PopDATE is a TSR Calendar written entirely in generic C. The `w\
  secret behind its size (`2TSR < 3.5k`0) and speed is `4 CodeRunneR `0, `w\
  the finest TSR library for C and assembler.  CodeRunneR helps `w\
  you create the first day, with the `1ease of C`0, TSRs rivaling the `w\
  best professional assembler programs in size & speed. `w\
`5`w\
  `3`0 CodeRunneR has over `1300 func's`0, hand-crafted in pure assembler. `w\
  `3`0 Initialization code and data `1AUTO-RELEASED`0 from TSR memory. `w\
  `3`0 `1Multitasking`0, dynamic `1hot-keys`0, `1scheduler`0, sw/hdw interrupts. `w\
  `3`0 Load TSR to `1LIM`0/`1UMB`0s. `1Spawn`0/`1swap`0 apps/`1graphics`0 to XMS/EMS/disk. `w\
  `3`0 Transparent `1DOS`0/file acces. `1Auto-sensed`0 video, new keyboards. `w\
  `3`0 `1BCD math`0, up to `1248`0 digits. Fast `1background`0, multiport COMs. `w\
  `3`0 Context sensitive `1hypertext help`0.  Quick-Start `1templates`0. `w\
  `3`0 `1In-depth`0 tech support, `1debug help`0 22 hours/day, 7 days/week. `w\
  `3`0 Source for PopDATE `1+ 10`0 other `1\"must-have\"`0 TSR utilities. `w\
`5`w`0\
 `0 For information call: `2 (508) 877-1819`0  or Fax: `2(508) 877-0915`0  `w\
   `[ `w`6 `r  ";


/* This is the signon message (uses dspf() control codes) */

char signon_scr[]= "`7"
	    "`m"
	    "`8    PopDATE 1.26      `7`m"
	    "`9            `7`m"
	    "`:  Copyright (c) 1992  `7`m"
	    "`:   Omega Point, Inc.  `7`m"
	    "`9           `7`m"
	    "`;     Written by       `7`m"
	    "`;   Ratko V. Tomic     `7`m"
	    "`9           `7`m"
	    "`8      To Invoke       `7`m"
	    "`:     Ctl-Shift-D      `7`m"
	    "`9           `7`m"
	    "`8      To Unload       `7`m"
	    "`;     POPDATE  /U      `7`m"
	    "`n";


char already[]="PopDATE already loaded.  Use PopDATE /U to unload";
char unl_ok[]="PopDATE has been unloaded.";
char unl_err[]="PopDATE could not be removed from memory.";

/**** CALENDAR BOX & ATTRIBUTES ****/

byte txtm[]={0x07,0x0F,0x70,0x70,0x70,0x70}; /* cal_atr[] for mono scr */

byte catc[]={0x71,0x17,0x74,7};
byte catm[]={0x70,0x07,0x70,7};

char cal_box[]="`0"
"  Mon Tue Wed Thu Fri Sat Sun  `m`1"
"`@`\x1D`m`E`0"
" `2\x1B\x1A`0 May 26, 1992 `2\x12`0 12:45:19 PM `3";


/*************************************************************************
		STANDARD CodeRunner VARIABLES
**************************************************************************/

char _tsr_name[]="PopDATE (C) 1992 OP";  /* TSR (c) msg for MM */

struct cfg_rec config_block = {
	sizeof(config_block),	/* Configuration block size */
	'P','D','A','T',	/* Program ID string */
	126			/* Program Version 1.26 (must be Non-Zero */
				/* Other user defined items may follow */
	};


word hk_list[]={0x20+M_LS+M_LC,0};

fp install_list[]={install_hk};

word init_data_end=1;
